"""Javascript helpers."""

import typing as t

from typing_extensions import NotRequired, TypedDict


class Events(TypedDict):
    """Event handlers."""

    onabort: NotRequired[t.Union[str, t.Callable]]
    onafterprint: NotRequired[t.Union[str, t.Callable]]
    onanimationend: NotRequired[t.Union[str, t.Callable]]
    onanimationiteration: NotRequired[t.Union[str, t.Callable]]
    onanimationstart: NotRequired[t.Union[str, t.Callable]]
    onbeforeprint: NotRequired[t.Union[str, t.Callable]]
    onbeforeunload: NotRequired[t.Union[str, t.Callable]]
    onblur: NotRequired[t.Union[str, t.Callable]]
    oncanplay: NotRequired[t.Union[str, t.Callable]]
    oncanplaythrough: NotRequired[t.Union[str, t.Callable]]
    onchange: NotRequired[t.Union[str, t.Callable]]
    onclick: NotRequired[t.Union[str, t.Callable]]
    oncontextmenu: NotRequired[t.Union[str, t.Callable]]
    oncopy: NotRequired[t.Union[str, t.Callable]]
    oncut: NotRequired[t.Union[str, t.Callable]]
    ondblclick: NotRequired[t.Union[str, t.Callable]]
    ondrag: NotRequired[t.Union[str, t.Callable]]
    ondragend: NotRequired[t.Union[str, t.Callable]]
    ondragenter: NotRequired[t.Union[str, t.Callable]]
    ondragleave: NotRequired[t.Union[str, t.Callable]]
    ondragover: NotRequired[t.Union[str, t.Callable]]
    ondragstart: NotRequired[t.Union[str, t.Callable]]
    ondrop: NotRequired[t.Union[str, t.Callable]]
    ondurationchange: NotRequired[t.Union[str, t.Callable]]
    onended: NotRequired[t.Union[str, t.Callable]]
    onerror: NotRequired[t.Union[str, t.Callable]]
    onfocus: NotRequired[t.Union[str, t.Callable]]
    onfocusin: NotRequired[t.Union[str, t.Callable]]
    onfocusout: NotRequired[t.Union[str, t.Callable]]
    onfullscreenchange: NotRequired[t.Union[str, t.Callable]]
    onfullscreenerror: NotRequired[t.Union[str, t.Callable]]
    onhashchange: NotRequired[t.Union[str, t.Callable]]
    oninput: NotRequired[t.Union[str, t.Callable]]
    oninvalid: NotRequired[t.Union[str, t.Callable]]
    onkeydown: NotRequired[t.Union[str, t.Callable]]
    onkeypress: NotRequired[t.Union[str, t.Callable]]
    onkeyup: NotRequired[t.Union[str, t.Callable]]
    onload: NotRequired[t.Union[str, t.Callable]]
    onloadeddata: NotRequired[t.Union[str, t.Callable]]
    onloadedmetadata: NotRequired[t.Union[str, t.Callable]]
    onloadstart: NotRequired[t.Union[str, t.Callable]]
    onmessage: NotRequired[t.Union[str, t.Callable]]
    onmousedown: NotRequired[t.Union[str, t.Callable]]
    onmouseenter: NotRequired[t.Union[str, t.Callable]]
    onmouseleave: NotRequired[t.Union[str, t.Callable]]
    onmousemove: NotRequired[t.Union[str, t.Callable]]
    onmouseover: NotRequired[t.Union[str, t.Callable]]
    onmouseout: NotRequired[t.Union[str, t.Callable]]
    onmouseup: NotRequired[t.Union[str, t.Callable]]
    onmousewheel: NotRequired[t.Union[str, t.Callable]]
    onoffline: NotRequired[t.Union[str, t.Callable]]
    ononline: NotRequired[t.Union[str, t.Callable]]
    onopen: NotRequired[t.Union[str, t.Callable]]
    onpagehide: NotRequired[t.Union[str, t.Callable]]
    onpageshow: NotRequired[t.Union[str, t.Callable]]
    onpaste: NotRequired[t.Union[str, t.Callable]]
    onpause: NotRequired[t.Union[str, t.Callable]]
    onplay: NotRequired[t.Union[str, t.Callable]]
    onplaying: NotRequired[t.Union[str, t.Callable]]
    onpopstate: NotRequired[t.Union[str, t.Callable]]
    onprogress: NotRequired[t.Union[str, t.Callable]]
    onratechange: NotRequired[t.Union[str, t.Callable]]
    onresize: NotRequired[t.Union[str, t.Callable]]
    onreset: NotRequired[t.Union[str, t.Callable]]
    onscroll: NotRequired[t.Union[str, t.Callable]]
    onsearch: NotRequired[t.Union[str, t.Callable]]
    onseeked: NotRequired[t.Union[str, t.Callable]]
    onseeking: NotRequired[t.Union[str, t.Callable]]
    onselect: NotRequired[t.Union[str, t.Callable]]
    onshow: NotRequired[t.Union[str, t.Callable]]
    onstalled: NotRequired[t.Union[str, t.Callable]]
    onstorage: NotRequired[t.Union[str, t.Callable]]
    onsubmit: NotRequired[t.Union[str, t.Callable]]
    onsuspend: NotRequired[t.Union[str, t.Callable]]
    ontimeupdate: NotRequired[t.Union[str, t.Callable]]
    ontoggle: NotRequired[t.Union[str, t.Callable]]
    ontouchcancel: NotRequired[t.Union[str, t.Callable]]
    ontouchend: NotRequired[t.Union[str, t.Callable]]
    ontouchmove: NotRequired[t.Union[str, t.Callable]]
    ontouchstart: NotRequired[t.Union[str, t.Callable]]
    ontransitionend: NotRequired[t.Union[str, t.Callable]]
    onunload: NotRequired[t.Union[str, t.Callable]]
    onvolumechange: NotRequired[t.Union[str, t.Callable]]
    onwaiting: NotRequired[t.Union[str, t.Callable]]
    onwheel: NotRequired[t.Union[str, t.Callable]]
